package com.kingdee.eas.custom.dormitorysystem.application.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.*;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.PersonDormitoryTypeInfo;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.affair.AffairBizException;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.base.HRBaseException;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.eas.hr.emp.PersonPositionFactory;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.shr.base.syssetting.BaseItemException;
import com.kingdee.shr.base.syssetting.BasicItemStateEnum;
import com.kingdee.shr.base.syssetting.IMSFServiceFacade;
import com.kingdee.shr.base.syssetting.MSFServiceFacadeFactory;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.util.*;

public class CheckoutApplicationControllerBean extends AbstractCheckoutApplicationControllerBean {
    private static Logger logger = Logger.getLogger(CheckoutApplicationControllerBean.class);

    /**
     * ɾ
     *
     * @param ctx
     * @param pk
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _delete(Context ctx, IObjectPK pk) throws BOSException, EASBizException {
        HRBillBaseInfo info = (HRBillBaseInfo) this._getValue(ctx, pk);
        HRBillStateEnum billState = info.getBillState();
        boolean isRemovable = true;
        //ύСͨĵݲɾ
        if (HRBillStateEnum.SUBMITED.equals(billState)
                || HRBillStateEnum.AUDITING.equals(billState)
                || HRBillStateEnum.AUDITED.equals(billState)) {
            isRemovable = false;
        }
        if (!isRemovable) {
            throw new AffairBizException(AffairBizException.BILLCANTDELETE);
        }
        super._delete(ctx, pk);
    }


    /**
     * ύЧ
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _submitEffect(Context ctx, String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪ!"});
        }
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("entrys.*");
        sic.add("entrys.occupants.*");
        //У鵥
        CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billId), sic);
        HRBillStateEnum billState = info.getBillState();
        if (HRBillStateEnum.AUDITED.equals(billState)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"Ѿͨظ"});
        }
//        Map<String, String> params = new HashMap<String, String>();
//        params.put("billIds", billId);
//        Map result = null;
//        try {
//            IMSFServiceFacade imsfServiceFacade = MSFServiceFacadeFactory.getLocalInstance(ctx);
//            result = (Map) imsfServiceFacade.processService("validateRoomAvailableByBillIdsService", params);
//        } catch (Exception e) {
//            logger.error(e);
//            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"ýӿvalidateRoomAvailableByBillIdsService: " + e.getMessage()});
//        }
//        Integer code = (Integer) result.get("code");
//        if (500 == code) {
//            List<String> errorMsgList = (List<String>) result.get("errorMsg");
//            StringBuilder errorMsgBuilder = new StringBuilder();
//            for (String errorMsg : errorMsgList) {
//                errorMsgBuilder.append(errorMsg).append("\n");
//            }
//            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{errorMsgBuilder.toString()});
//        }
//        //Уס뵥ǷظύУסϢʱ佻
//        Map result2 = null;
//        try {
//            IMSFServiceFacade imsfServiceFacade = MSFServiceFacadeFactory.getLocalInstance(ctx);
//            result2 = (Map) imsfServiceFacade.processService("checkDuplicateCheckInByBillIdService", params);
//        } catch (Exception e) {
//            logger.error(e);
//            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"ýӿcheckDuplicateCheckInByBillIdService: " + e.getMessage()});
//        }
//        Integer code2 = (Integer) result2.get("code");
//        if (500 == code2) {
//            List<String> errorMsgList = (List<String>) result2.get("errorMsg");
//            StringBuilder errorMsgBuilder = new StringBuilder();
//            for (String errorMsg : errorMsgList) {
//                errorMsgBuilder.append(errorMsg).append("\n");
//            }
//            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{errorMsgBuilder.toString()});
//        }
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        CoreBaseCollection updateCols = new CoreBaseCollection();
        CheckoutApplicationEntryCollection entrys = info.getEntrys();
        for (int i = 0; i < entrys.size(); i++) {
            CheckoutApplicationEntryInfo entryInfo = entrys.get(i);
            Date checkoutDate = entryInfo.getCheckoutDate();
            OccupantsInfo occupants = entryInfo.getOccupants();
            occupants.setCheckOutDate(checkoutDate);
//            PersonInfo personInfo = entryInfo.getPerson();
//            String personId = personInfo.getId().toString();
//            //УԱùϵ״̬
//            IPerson iPerson = PersonFactory.getLocalInstance(ctx);
//            //SelectorItemCollection sic = new SelectorItemCollection();
//            //sic.add("");
//            personInfo = iPerson.getPersonInfo(new ObjectUuidPK(personId));
//            boolean isInCount = personInfo.getEmployeeType().isIsInCount();
//            if (!isInCount) {
//                //Աùϵ״̬
//                //
//            }
            //סԱϢ
            //УʱǷڽ
            updateCols.add(occupants);
        }
        //סϢ
        iOccupants.updateBatchData(updateCols);
        //
        //update(ctx, new ObjectUuidPK(billId), info);
        //ύ
        IObjectPK iObjectPK = super._submitEffect(ctx, info);
        return iObjectPK;
    }

    /**
     * ύЧ
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _submitEffect(
            Context ctx,
            CoreBaseInfo model
    ) throws BOSException, EASBizException {
        String billId = model.getId().toString();
        return _submitEffect(ctx, billId);
    }

    /**
     * 
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _untiCheckBizBill(
            Context ctx,
            String billId
    ) throws BOSException, EASBizException {
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("entrys.*");
        sic.add("entrys.person.*");
        sic.add("entrys.occupants.*");
        CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billId), sic);
        HRBillStateEnum billState = info.getBillState();
        if (!HRBillStateEnum.AUDITED.equals(billState)) {
            throw new AffairBizException(HRBaseException.BILLSTATECANUNCHECK);
        }
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        ICheckoutApplicationEntry iCheckoutApplicationEntry = CheckoutApplicationEntryFactory.getLocalInstance(ctx);
        CheckoutApplicationEntryCollection entrys = info.getEntrys();
        StringBuilder errorMsg = new StringBuilder();
        CoreBaseCollection updateCols = new CoreBaseCollection();
        for (int i = 0; i < entrys.size(); i++) {
            CheckoutApplicationEntryInfo entryInfo = entrys.get(i);
            //PersonInfo person = entryInfo.getPerson();
            OccupantsInfo occupants = entryInfo.getOccupants();
            String occupantsId = occupants.getId().toString();
            //Ƿ
//            RoomChangeApplicationEntryCollection roomChangeApplicationEntryCollection = iRoomChangeApplicationEntry.getRoomChangeApplicationEntryCollection("select parent.number where oldOccupants = '" + occupantsId + "'");
//            if (roomChangeApplicationEntryCollection.size() > 0) {
//                RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = roomChangeApplicationEntryCollection.get(0);
//                String number = roomChangeApplicationEntryInfo.getParent().getNumber();
//                errorMsg.append("Ա " + person.getName() + "л޵[ " + number + " ]ܷˣ\n");
//            }
            //Ƿл
//            CheckoutApplicationEntryCollection checkoutApplicationEntryCollection = iCheckoutApplicationEntry.getCheckoutApplicationEntryCollection("select parent.number where occupants = '" + occupantsId + "'");
//            if (checkoutApplicationEntryCollection.size() > 0) {
//                CheckoutApplicationEntryInfo checkoutApplicationEntryInfo = checkoutApplicationEntryCollection.get(0);
//                String number = checkoutApplicationEntryInfo.getParent().getNumber();
//                errorMsg.append("Ա " + person.getName() + "޵[ " + number + " ]ܷˣ\n");
//            }
            //ûˮϸĿԷ
            occupants.setCheckOutDate(entryInfo.getOldCheckoutDate());
            updateCols.add(occupants);
        }
        if (errorMsg.length() > 0) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{errorMsg.toString()});
        }
        super._untiCheckBizBill(ctx, billId);
        if (updateCols.size() > 0) {
            //סϢ
            iOccupants.updateBatchData(updateCols);
        }
    }
}